#!/usr/local/bin/perl
#
#	cmd_executor.pl
#
#	Execute the cacti cmd.php script with stdout and stderr directed to log file.
#	Timestamp the log with a single completion line that is as informative as possible.
#	No need to show the whole php commandline.
#
#	This also provides a single place to allow us to manipulate the execution environment
#	of the cmd.php script if we want to.  This script is mainly hardcoded and is pretty
#	basic, but does the job.
#
($b_usr,$b_sys,$b_cusr,$b_csys) = times;
$bwtime = time;
$btime = `/usr/bin/date +'%T'`;
chomp($btime);
#
$appgrp = @ARGV[0];
if ($appgrp eq "")
{
	print "Cmon! - Command line arg missing\n";
	exit 0;
}
#
#	You have to adjust these paths to your needs.
#	Here thy are organized so that a cacti web site exists directly under web_root.
#	The name of the cacti web site is passed by the caller in the commandline.
#	You could just pass "cacti" to fit the theoretical single instance installation.
#	In apache, you define a virtual host to each of the web_root/$appgrp sites.
#
$logfile     = "/home/cactiusr/web_root/$appgrp/log/cmd_php_execution.log";
$logfile_old = "/home/cactiusr/web_root/$appgrp/log/old_cmd_php_execution.log";
$rlgfile     = "/home/cactiusr/web_root/$appgrp/log/rrd.log";
$rlgfile_old = "/home/cactiusr/web_root/$appgrp/log/old_rrd.log";
#
#	Now do some code that checks the current time to see if it is Sunday and it is the
#	00:00AM thru 00:04AM execution of this script.  If yes, then cleanup the log files used
#	in this job so they are preserved with only last weeks log file retained.
#
#	A BIG ASSUMPTION is that this script will execute only once every 5 minutes!!!!!!
#
$c_weekday = (localtime)[6];
$c_hour    = (localtime)[2];
$c_minute  = (localtime)[1];
if ($c_weekday == 0)
{
	if ($c_hour == 0)
	{
		if ($c_minute <= 4)
		{
			if ( -e $logfile)
			{
				system( "/usr/bin/mv $logfile $logfile_old" );
			}
			if ( -e $rlgfile)
			{
				system( "/usr/bin/mv $rlgfile $rlgfile_old" );
			}
		}
	}
}
#
if ( ! -e $logfile )
{
	system( "/usr/bin/touch $logfile" );
}
#
if ( ! -e $rlgfile )
{
	system( "/usr/bin/touch $rlgfile" );
}
#
$php_cmd     = "/usr/local/bin/php -q";
$basecmd     = "/home/cactiuser/web_root/$appgrp/cmd.php";
$fullcmd     = "$php_cmd $basecmd >> $logfile 2>&1";
#
if ( -e $basecmd )
{
	system( "$fullcmd" );
}
#
#	Job Completion - now calc and output the timing info.
#
$ewtime = time;
$elsecs = $ewtime - $bwtime;
$elmins = int( $elsecs / 60 );
$rsecs  = $elsecs - ( $elmins * 60 );
#
formline( "@#m@#s" , $elmins,$rsecs );
$eltime = $^A;
$^A = "";
$eltime =~ tr / //d;
#
$etime = `/usr/bin/date +'%T %Y/%m/%d'`;
chomp($etime);
#
($e_usr,$e_sys,$e_cusr,$e_csys) = times;
$el_usr = $e_usr - $b_usr;
$el_sys = $e_sys - $b_sys;
$el_cusr = $e_cusr - $b_cusr;
$el_csys = $e_csys - $b_csys;
#
$usrcpu = $el_usr + $el_cusr;
$syscpu = $el_sys + $el_csys;
$totcpu = $usrcpu + $syscpu;
#              HH:MM:SS YYYY/MM/DD Elapsed: 99m59s cmd.php ran at HH:MM:SS UsrCPU:999.99 SysCPU:999.99 TotCPU:999.99
$FPIC = "Fini: @<<<<<<<<<<<<<<<<<< Elapsed: @<<<<< cmd.php ran at @<<<<<<< UsrCPU:@##.## SysCPU:@##.## TotCPU:@##.##";
formline( $FPIC , $etime, $eltime, $btime, $usrcpu, $syscpu, $totcpu );
$logline1 = $^A;
$^A = "";
#
open(LOG,">> $logfile") || die("Cannot open the log file");
print LOG "$logline1\n";
close(LOG);
#
exit 0;
