#!/usr/bin/perl
#
#	hpux_iostat_stats.pl
#
#	This program will execute an iostat command and collect the info, total and average it
#	and finally pass it to the caller via a single line of output to stdout.  The iteration count
#	could be as many as desired, but only the last generated disk data will be the stuff that is
#	retained and in the end, totaled and given to the caller.  Supposedly, the interval could be
#	whatever you wish as the iostat command does the data reduction to the per second value.
#
#	hpux iostat returns data in four columns as:
#		device   KBps   SeeksPerSecond  msps(useless milliseconds per average seek)
#

open( IOS, "/usr/bin/iostat 6 2 |" ) || die("Cannot do iostat command");

$dcount = 0;
# Line item associative array.
$dsk  = 0;
$kbps = 0;
$sps  = 0;
# Accumulators for Line items
$tot_kbps  = 0;
$avg_kbps  = 0;
$max_kbps  = 0;
$tot_sps   = 0;
$avg_sps   = 0;
$max_sps   = 0;

while (<IOS>)
{
	chomp;
	print "$_\n";
	if ( m/^\s*(c\d+t\d+d\d+)\s+(-*\d+\.*\d*)\s+(-*\d+\.*\d*)\s+(-*\d+\.\d*)/ )
	{
		$dsk{"$1"}  = $1;
		$kbps{"$1"} = $2;
		$sps{"$1"}  = $3;
	}
}
close(IOS);
foreach $akey (sort keys(%dsk))
{
	$dcount++;
	$tot_kbps  = $tot_kbps  + $kbps{$akey};
	$tot_sps   = $tot_sps   + $sps{$akey};
	$max_kbps  = $kbps{$akey} if ( $kbps{$akey} > $max_kbps  );
	$max_sps   = $sps{$akey}  if ( $sps{$akey}  > $max_sps   );
	print "$dcount $tot_kbps $avg_kbps $max_kbps $tot_sps $avg_sps $max_sps\n";
}
if ( $dcount > 0 )
{
	$avg_kbps  = int( ($tot_kbps  / $dcount) * 10 ) / 10;
	$avg_sps   = int( ($tot_sps   / $dcount) * 10 ) / 10;
}
print "$dcount $tot_kbps $avg_kbps $max_kbps $tot_sps $avg_sps $max_sps";
exit 0;
