#
#	This is a function that will query a given netsaint client and return the results
#	as the function return value.  It's pretty basic, but a building block...
#
#	This should be included into another perl program to allow its usage.
#	This script would be ideally placed into /usr/local/netsaint alongside
#	the netsaint_statd daemon perl script.
#
sub query_netsaint
{
	#
	#	Program to query a remote netsaint_statd daemon for some piece of information.
	#
	#	Usage:
	#		$scalar = &query_netsaint( <host>, <command>);
	#
	#	The result of the commands successful and proper execution is that the data that
	#	was queried for will simply be echoed to stdout.  This program is meant to be used as
	#	a helper/worker script for use by the cacti package.
	#

	require 5.003;
	use POSIX;
	use IO::Socket;
	use strict;

	my $the_host   = "";
	my $the_msg    = "";
	my $the_port   = "1040";
	my $the_answer = "";
	my $the_socket = "";

	$the_host = @ARGV[0];
	$the_msg  = @ARGV[1];

	if ($the_host eq "")
	{
		print "Missing target hostname argument\n";
		exit 0;
	}

	if ($the_msg eq "")
	{
		print "Missing target command/message to send argument\n";
		exit 0;
	}

	$the_socket = IO::Socket::INET->new(PeerAddr => "$the_host:$the_port") or die "Couldn't connect to $the_host:$the_port : $@\n";
	print $the_socket "$the_msg\n";
	$the_answer = <$the_socket>;
	close($the_socket);
	return($the_answer);
}
1;
